﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridHeaderDropdown
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            mainGrid.DisplayLayout.Override.CellClickAction = CellClickAction.CellSelect;
            detailGrid.DisplayLayout.Override.CellClickAction = CellClickAction.CellSelect;
            detailGrid.DisplayLayout.Override.RowSelectors = DefaultableBoolean.False;

            foreach (UltraGridColumn col in detailGrid.DisplayLayout.Bands[0].Columns)
                col.Hidden = true;

            detailGrid.DisplayLayout.Bands[0].Columns[0].Hidden = false;

            DataTable dt = new DataTable();
            dt.Columns.Add("Columns", typeof(string));
            foreach (UltraGridColumn col in mainGrid.DisplayLayout.Bands[0].Columns)
                dt.Rows.Add(col.Header.Caption);

            ultraCombo1.DataSource = dt;
            ultraCombo1.DropDownStyle = UltraComboStyle.DropDownList;
            ultraCombo1.DisplayLayout.Bands[0].ColHeadersVisible = false;

            detailGrid.CreationFilter = new DropDownPositionCreationFilter(ultraCombo1, detailGrid);

            ultraCombo1.Value = "ID";
            mainGrid.ActiveCell = mainGrid.Rows[0].Cells[0];
        }

        private void mainGrid_AfterCellActivate(object sender, EventArgs e)
        {
            int rowID = (int)mainGrid.ActiveCell.Row.GetCellValue("ID");
            detailGrid.Rows.ColumnFilters[0].FilterConditions.Clear();
            detailGrid.Rows.ColumnFilters[0].FilterConditions.Add(new FilterCondition(FilterComparisionOperator.Equals, rowID));
        }

        private void ultraCombo1_ValueChanged(object sender, EventArgs e)
        {
            foreach (UltraGridColumn col in detailGrid.DisplayLayout.Bands[0].Columns)
                col.Hidden = true;

            detailGrid.DisplayLayout.Bands[0].Columns[ultraCombo1.Text].Hidden = false;
        }
    }

    public class DropDownPositionCreationFilter : IUIElementCreationFilter
    {
        UltraCombo comboToPlace = null;
        UltraGrid appliedGrid = null;

        public DropDownPositionCreationFilter(UltraCombo combo, UltraGrid grid)
        {
            comboToPlace = combo;
            appliedGrid = grid;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is HeaderUIElement)
            {
                Point comboLocation = parent.Rect.Location;
                comboLocation.Offset(appliedGrid.Location);
                comboToPlace.Location = comboLocation;

                HeaderBase columnHeader = appliedGrid.DisplayLayout.ColScrollRegions[0].VisibleHeaders[0].Header;

                comboToPlace.Width = columnHeader.Column.Width;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
